Program EloRendezettekVizsgalata; {SzP 1995.10.20}
{ -------------------------------------------------------------------------
        Menz programkeret a gyakorisgszerint, ill.
			    az orgonasp-elrendezett tmb vizsglathoz.
        Vizsglat:
        - a gyakorisg figyelembe vtele nlkl,
        - a gyakorisg gyenge figyelembe vtelvel,
        - a gyakorisg ers figyelembe vtelvel.
        rtelmezsek:
          a tmb elemeire trtn hivatkozs
          "ers"   = ha pl. az indexsorozat: 111111111,2222,3,
          "gyenge" = ha pl. az indexsorozat: 111,22,3,
  ------------------------------------------------------------------------- }
  Uses
     Newdelay,Crt;
  Const
     MaxN = 12; {< karakteres sor szlessge}
     MaxIndexTombHossz = MaxN*MaxN*MaxN;
  Type
     Gyakorisag = Array [1..MaxN] of Byte;
     IndexTomb  = Array [1..MaxIndexTombHossz] of Integer;
  Var
     N : Integer;
     el: Gyakorisag;
     index: IndexTomb;
     hossz,
     ossz : Word;

 {$i erenmenu.pas}

  Procedure Nullazas(Var el: Gyakorisag);
    Var
      i: Word;
  Begin
    For i:=1 to N do el[i]:=0;
  End;

  Procedure IndexTombFoltoltes(vizsg:VizsgalatFajta;
                               Var index:IndexTomb; Var hossz:Word);
    Var
      i,j: Word;
  Begin
    Case vizsg of
       Fgtlen    : Begin
                     hossz:=0;
                     For i:=1 to N do For j:=1 to N do
                     Begin
                       Inc(hossz); index[hossz]:=i;
                     End;
                   End;
       GyengenFgo: Begin
                     hossz:=0;
                     For i:=N downto 1 do
                     Begin
                       For j:=1 to i do
                       Begin
                         Inc(hossz); index[hossz]:=N-i+1;
                       End;
                     End;
                   End;
       ErosenFgo : Begin
                     hossz:=0;
                     For i:=N downto 1 do
                     Begin
                       For j:=1 to i*i do
                       Begin
                         Inc(hossz); index[hossz]:=N-i+1;
                       End;
                     End;
                   End;
    End;
  End;

  Procedure EloszlasMegjelenites(elo:Gyakorisag; ossz:Word);
    Var
       i  :Integer;
       atl:Real;
  Begin
    ClrScr;
    For i:=1 to N do Writeln(i:6,':',elo[i]/ossz:6:4);
    atl:=0;
    For i:=1 to N do atl:=atl+i*elo[i]/ossz;
    Writeln('Atlag:',atl:6:4);
  End;

  Procedure Kihagy(Var index:IndexTomb; melyik:Integer; Var hossz:Word);
    Var
       i:Integer;
  Begin
    For i:=melyik+1 to hossz do index[i-1]:=index[i]; Dec(hossz);
  End;

  Function Hol(N,melyik:Integer; eloRend:RendezesFajta):Integer;
     Var
       kozep:Integer;
  Begin
    If Odd(N) then
    Begin
      kozep:=(N+1) Div 2;
      If Odd(melyik) then Hol:=kozep+(melyik Div 2)
                     else Hol:=kozep-(melyik Div 2);
    End
      else
    Begin
      kozep:=N Div 2;
      If Odd(melyik) then Hol:=kozep-(melyik Div 2)
                     else Hol:=kozep+(melyik Div 2);
    End;
  End;

  Procedure Vizsgalat(eloRend:RendezesFajta; vizsg: VizsgalatFajta);
    Var
       utso,
       melyik,
       i,j,
       szor  : Integer;
  Begin
    Nullazas(el);
    If eloRend=Lin then szor:=1 else szor:=8;
    For i:=1 to szor do
    Begin
      utso:=1;
      IndexTombFoltoltes(vizsg{=>}, index,hossz); ossz:=hossz;
      While hossz>0 do
      Begin
        j:=Random(hossz)+1; melyik:=Hol(N,index[j],eloRend);
        Kihagy(index,j,hossz);
        Inc(el[Abs(melyik-utso)+1]);
        If eloRend=Lin then utso:=1 else utso:=melyik
      End;
      EloszlasMegjelenites(el,ossz*szor);
    End;
  End;

Begin
  N:=MaxN;
  AblakRajzolas(1,1,25,79,'',FoMenu.keret,FoMenu.papir);
  kepVer:=Nil;
  utolsoMelyik:=Menuzes(FoMenu);
End.