Program N_Vezer;
  Uses
     Newdelay,Crt,Graph,CursUnit;
  Const
     MaxN  = 10;
  Type
     Index = 0..MaxN+1;
     Tabla = Array [1..MaxN] of (Ures,Foglalt);
     Hol   = Array [1..MaxN] of Index;
  Var
     Vezer : Hol;
     i: -1..MaxN;
     N,j,
     hova  : Index;
     lehet : Boolean;
   { megjelentsi paramterek: }
     bfx,bfy,
     jax,jay: Integer; { tblasarkak }
     mOldal : Integer; { egy mez oldalnak hossza }

  Procedure Varakozas(meddig: Integer);
    Var
      c: Char;
  Begin
    If meddig<=0 then
    Begin
      Repeat Until KeyPressed; c:=ReadKey;
    End
      else
    Begin
      Delay(meddig*1000);
      If KeyPressed then
      Begin
        c:=ReadKey;
        Repeat Delay(1000); Until KeyPressed;
        c:=ReadKey;
      End;
    End;
  End; {Vrakozs}

  Procedure MezoRajz(x,y: Integer; szin: Integer);
  Begin
    Window(bfx+2*mOldal*(x-1),bfy+mOldal*(y-1),bfx+2*mOldal*x-1,bfy+mOldal*y-1);
    TextBackGround(szin); ClrScr;
  End; {MezRajz}

  Procedure BabuRajz(x,y: Integer; hszin,bszin: Integer);
    Var
      balx,baly: Integer;
  Begin
    balx:=bfx+2*mOldal*(x-1); baly:=bfy+mOldal*(y-1);
    Window(balx,baly,balx+2*mOldal-1,baly+mOldal-1);
    TextBackGround(hszin); TextColor(bszin);
    GotoXY(mOldal,(mOldal Div 2)+1); Write(''{=2});
  End; {BbuRajz}

  Procedure Inicializalas(Var n: Index);
    Var
      i,j: Integer;
  Begin
    Window(1,1, 80,25); TextColor(White); TextBackGround(Black); ClrScr;
    Writeln('N-vezrproblma':48);
    Repeat
      GotoXY(1,5); Write('Vezrszm (1<N<',MaxN:2,'):'); Readln(n)
    Until n in [2..MaxN];
    Window(1,2, 80,25); ClrScr;
    mOldal:=22 Div n;
    bfy:=2+(22 Div n) Div 2;    jay:=bfy+n*mOldal-1;
    bfx:=(80-2*n*mOldal) Div 2; jax:=bfx+2*n*mOldal;
    Window(bfx-1,bfy-1, jax+1,jay+1); TextColor(White); TextBackGround(Brown); ClrScr;
    Window(1,1, 80,25); {Ablakvisszallts}
    For i:=1 to n do For j:=1 to n do
    Begin
      If ((i+j) Mod 2)=0 then MezoRajz(i,j,White) else MezoRajz(i,j,Black);
    End
  End;

  Procedure Letesz(i,j: Index; proba:Boolean);
  Begin
    If proba then
      If ((i+j) Mod 2)=0 then BabuRajz(i,j,White,Red)
                         else BabuRajz(i,j,Black,Yellow)
    Else
      If ((i+j) Mod 2)=0 then BabuRajz(i,j,White,Black)
                         else BabuRajz(i,j,Black,White);
  End; {Letesz}

  Procedure Folvesz(i,j: Index);
  Begin
    If ((i+j) Mod 2)=0 then MezoRajz(i,j,White) else MezoRajz(i,j,Black);
  End; {Folvesz}

  Procedure VanMegoldas(n: Index);
    Var
      i,j: Index;
  Begin
    Window(1,1, 80,25); TextColor(White); TextBackGround(Black); ClrScr;
    Write('Az N-vezrproblmnak N=',n,' esetre van megoldsa, mgpedig az albbi:');
    Window(bfx-1,bfy-1, jax+1,jay+1); TextColor(White); TextBackGround(Brown); ClrScr;
    Window(1,1, 80,25); {Ablakvisszallts}
    For i:=1 to n do For j:=1 to n do
    Begin
      If ((i+j) Mod 2)=0 then
      Begin
        MezoRajz(i,j,White);
        If Vezer[i]=j then BabuRajz(i,j,White,Black);
      End
        else
      Begin
        MezoRajz(i,j,Black);
        If Vezer[i]=j then BabuRajz(i,j,Black,White);
      End;
    End;
    Varakozas(0);
  End;

  Procedure NincsMegoldas(n: Index);
  Begin
    Window(1,1, 80,25); TextColor(White); TextBackGround(Black); ClrScr;
    Write('Az N-vezrproblmnak N=',n,' esetre nincs megoldsa.');
    Varakozas(0);
  End;

  Function Uti(vx1,vy1, vx2,vy2: Index): Boolean;
  Begin
    Uti:=(vy1=vy2) or (Abs(vy1-vy2)=vx1-vx2)
  End; {Uti}

  Function RosszEset(x,y: Index): Boolean;
    Var
       j: Index;
  Begin
    Letesz(x,y,True);
    j:=1;
    While (j<=x-1) and not uti(x,y, j,Vezer[j]) do
    Begin
      Inc(j);
    End;
    Varakozas(1); Folvesz(x,y);
    RosszEset:=j<=x-1
  End;

  Procedure VanJoEset(i: Index; Var talan: Boolean; Var ide: Index);
  Begin
    ide:=Vezer[i]+1;
    While (ide<=N) and RosszEset(i,ide) do Inc(ide);
    talan:=ide<=N;
  End;

Begin
  Inicializalas(N);
  CurOff;
  i:=1; Vezer[1]:=1; Letesz(i,1,False);
  For j:=2 to N do Vezer[j]:=0;
  While i+1 in [1..N] do
  Begin
    Varakozas(5);
    VanJoEset(i+1,lehet,hova);
    If lehet then
    Begin
      Letesz(i+1,hova,False); Inc(i); Vezer[i]:=hova;
    End
      else
    Begin
      If i>0 then
      Begin
        Folvesz(i,Vezer[i]); Vezer[i+1]:=0;
      End;
      Dec(i);
    End;

  End;
  If i>0 then VanMegoldas(N)
         else NincsMegoldas(N);
  CurOn;
End.
